import { randomUUID } from 'crypto';
const activeTokens = [];
const maxTokens = 1024;
let tokenIndex = 0;
function newToken() {
    const token = randomUUID().replace(/\-/g, '');
    activeTokens[tokenIndex++] = token;
    if (tokenIndex === maxTokens) {
        tokenIndex = 0;
    }
    return token;
}
export function generateToken(options, { password, username }) {
    const accounts = options.accounts || [];
    const user = username.toUpperCase();
    for (const account of accounts) {
        if (account.username.toUpperCase() === user && account.password === password) {
            return newToken();
        }
    }
    return undefined;
}
export function validateToken(_options, token) {
    return activeTokens.indexOf(token) !== -1;
}
