export function sendResponse(req, ans, res) {
    const origin = req.headers.origin;
    const type = ans.headers['content-type'];
    if (origin) {
        res.setHeader('Access-Control-Allow-Origin', origin);
    }
    res.setHeader('Access-Control-Allow-Credentials', 'true');
    res.setHeader('Content-Type', type);
    res.statusCode = ans.status.code;
    res.end(ans.content);
}
export function withBody(callback) {
    return (req, res) => {
        const bodyParts = [];
        return req
            .on('data', (chunk) => bodyParts.push(chunk))
            .on('end', () => {
            req.body = Buffer.concat(bodyParts).toString();
            callback(req, res);
        });
    };
}
export function corsHandler(req, res) {
    const origin = req.headers.origin;
    const headers = ['authorization', 'content-type'];
    const requestHeaders = req.headers['access-control-request-headers'];
    if (requestHeaders) {
        headers.push(requestHeaders);
    }
    res.statusCode = 200;
    res.setHeader('Access-Control-Allow-Origin', origin);
    res.setHeader('Access-Control-Allow-Headers', headers.join(','));
    res.setHeader('Access-Control-Allow-Methods', 'GET,POST,PUT,DELETE');
    res.setHeader('Access-Control-Allow-Credentials', 'true');
    return res.end();
}
