export function configureHandler(server, config) {
    const handlers = config && config.handlers;
    if (handlers) {
        for (const url of Object.keys(handlers)) {
            const handler = handlers[url];
            server.at(url).any(handler);
        }
    }
}
export function runWith(server, callback) {
    return server
        .start()
        .then(() => callback(server))
        .then(() => server.stop());
}
