import { asJson, toFile } from './io';
function all(_item) {
    return true;
}
function none(_item) {
    return false;
}
export class JsonStore {
    file;
    constructor(file) {
        this.file = file;
    }
    insert(item) {
        const file = this.file;
        const items = asJson(file, []);
        items.push(item);
        toFile(file, items);
    }
    delete(predicate) {
        const file = this.file;
        const items = asJson(file, undefined);
        if (items && items.length) {
            for (let i = items.length; i--;) {
                if ((predicate || none)(items[i])) {
                    items.splice(i, 1);
                }
            }
            toFile(file, items);
        }
    }
    select(predicate) {
        const file = this.file;
        const items = asJson(file, []);
        return items.filter(predicate || all);
    }
    switchTo(file) {
        this.file = file;
    }
}
export function open(file) {
    return new JsonStore(file);
}
