import { filterReverse } from '../helpers';
const maxEntries = 50;
export function recentLogsOf(server) {
    return (req, res) => {
        res.json({
            entries: filterReverse(server.logs, (_1, _2, i) => i < maxEntries),
        });
    };
}
export function allLogsOf(server) {
    return (req, res) => {
        server.logs.splice(0, server.logs.length);
        res.sendStatus(200);
    };
}
export function liveLogs(server) {
    const clients = [];
    const broadcast = (entry) => {
        for (const client of clients) {
            client.send(JSON.stringify(entry));
        }
    };
    server.on('logged', (item) => {
        broadcast(item);
    });
    return (ws) => {
        clients.push(ws);
        ws.on('close', () => {
            clients.splice(clients.indexOf(ws), 1);
        });
    };
}
